#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,int *A1,int *A2,int *A3,int *A4,int *A5,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,float *B7,float *B8,int N){
for(int i=0;i<N;i++){
A0[i] = A3[i]+A5[i];
A1[i] = A4[i];
B0[i] = B8[i]*B8[i]+B8[i];
B1[i] = B8[i]/B8[i];
B2[i] = B8[i]-B8[i]-B8[i]+B8[i];
B3[i] = B8[i]-B8[i]-B8[i];
B4[i] = B8[i]-B8[i];
B5[i] = B8[i]-B8[i];
B6[i] = B8[i]/B8[i];
B7[i] = B8[i]/B8[i];
}
}

int main(int argc,char **argv) {
int size=23322;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
int *A2;
A2 = (int *)malloc(intBytes);
int *A3;
A3 = (int *)malloc(intBytes);
int *A4;
A4 = (int *)malloc(intBytes);
int *A5;
A5 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
float *B6;
B6 = (float *)malloc(floatBytes);
float *B7;
B7 = (float *)malloc(floatBytes);
float *B8;
B8 = (float *)malloc(floatBytes);
for(int i=0;i<23322;i++){
A0[i] = 46+i+1;
A1[i] = 43*i+1;
A2[i] = 42*i+1;
A3[i] = 84+i+1;
A4[i] = 80*i+1;
A5[i] = 15+i+1;
B0[i] = 25.8487345335+i+1;
B1[i] = 40.3955116281+i+1;
B2[i] = 43.0684431043+i+1;
B3[i] = 60.8954383675+i+1;
B4[i] = 74.0882859154+i+1;
B5[i] = 89.3308352474+i+1;
B6[i] = 33.0174193211+i+1;
B7[i] = 0.960462271931+i+1;
B8[i] = 46.4574586693*i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,A1,A2,A3,A4,A5,B0,B1,B2,B3,B4,B5,B6,B7,B8,23322);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(A1);
free(A2);
free(A3);
free(A4);
free(A5);
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
free(B5);
free(B6);
free(B7);
free(B8);
printf("\n");return 0; }